Index: gnu/usr.bin/perl/t/op/lop.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/op/lop.t,v
retrieving revision 1.1.1.4
diff -u -p -r1.1.1.4 lop.t
--- gnu/usr.bin/perl/t/op/lop.t	24 Mar 2014 14:59:10 -0000	1.1.1.4
+++ gnu/usr.bin/perl/t/op/lop.t	14 Sep 2017 02:23:20 -0000
@@ -10,7 +10,7 @@ BEGIN {
     require './test.pl';
 }
 
-plan tests => 17;
+plan tests => 23;
 
 for my $i (undef, 0 .. 2, "", "0 but true") {
     my $true = 1;
@@ -56,3 +56,29 @@ is( $i, 10, 'negation precedence with &&
 ++$y;
 $i = !$x && !$x && !$x && $y;
 is( $i, 11, 'negation precedence with &&, multiple operands' );
+
+# [perl #127952]. This relates to OP_AND and OP_OR with a negated constant
+# on the lhs (either a negated bareword, or a negation of a do{} containing
+# a constant) and a negated non-foldable expression on the rhs. These cases
+# yielded 42 or "Bare" or "str" before the bug was fixed.
+{
+    $x = 42;
+
+    $i = !Bare || !$x;
+    is( $i, '', 'neg-bareword on lhs of || with non-foldable neg-true on rhs' );
+
+    $i = !Bare && !$x;
+    is( $i, '', 'neg-bareword on lhs of && with non-foldable neg-true on rhs' );
+
+    $i = do { !$x if !Bare };
+    is( $i, '', 'neg-bareword on rhs of modifier-if with non-foldable neg-true on lhs' );
+
+    $i = do { !$x unless !Bare };
+    is( $i, '', 'neg-bareword on rhs of modifier-unless with non-foldable neg-true on lhs' );
+
+    $i = !do { "str" } || !$x;
+    is( $i, '', 'neg-do-const on lhs of || with non-foldable neg-true on rhs' );
+
+    $i = !do { "str" } && !$x;
+    is( $i, '', 'neg-do-const on lhs of && with non-foldable neg-true on rhs' );
+}
Index: gnu/usr.bin/perl/t/op/method.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/op/method.t,v
retrieving revision 1.12
diff -u -p -r1.12 method.t
--- gnu/usr.bin/perl/t/op/method.t	5 Feb 2017 00:32:20 -0000	1.12
+++ gnu/usr.bin/perl/t/op/method.t	14 Sep 2017 02:23:20 -0000
@@ -13,7 +13,7 @@ BEGIN {
 use strict;
 no warnings 'once';
 
-plan(tests => 150);
+plan(tests => 151);
 
 @A::ISA = 'B';
 @B::ISA = 'C';
@@ -703,6 +703,10 @@ SKIP: {
     fresh_perl_is('Unknown->import() * Unknown->unimport(); print "ok\n"', "ok\n", {},
                   "check unknown import() methods don't corrupt the stack");
 }
+
+like runperl(prog => 'sub ub(){0} ub ub', stderr=>1), qr/Bareword found/,
+ '[perl #126482] Assert failure when mentioning a constant twice in a row';
+
 
 __END__
 #FF9900
Index: gnu/usr.bin/perl/t/op/require_errors.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/op/require_errors.t,v
retrieving revision 1.2
diff -u -p -r1.2 require_errors.t
--- gnu/usr.bin/perl/t/op/require_errors.t	5 Feb 2017 00:32:20 -0000	1.2
+++ gnu/usr.bin/perl/t/op/require_errors.t	14 Sep 2017 02:23:21 -0000
@@ -8,7 +8,7 @@ BEGIN {
 use strict;
 use warnings;
 
-plan(tests => 17);
+plan(tests => 19);
 
 my $nonfile = tempfile();
 
@@ -134,3 +134,11 @@ like $@, qr/^Can't locate strict\.pm\\0i
 eval "require strict\0::invalid;";
 like $@, qr/^syntax error at \(eval \d+\) line 1/, 'parse error with \0 in barewords module names';
 
+# Refs and globs that stringify with embedded nulls
+# These crashed from 5.20 to 5.24 [perl #128182].
+eval { no warnings 'syscalls'; require eval "qr/\0/" };
+like $@, qr/^Can't locate \(\?\^:\\0\):/,
+    'require ref that stringifies with embedded null';
+eval { no strict; no warnings 'syscalls'; require *{"\0a"} };
+like $@, qr/^Can't locate \*main::\\0a:/,
+    'require ref that stringifies with embedded null';
Index: gnu/usr.bin/perl/t/op/reset.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/op/reset.t,v
retrieving revision 1.2
diff -u -p -r1.2 reset.t
--- gnu/usr.bin/perl/t/op/reset.t	5 Feb 2017 00:32:20 -0000	1.2
+++ gnu/usr.bin/perl/t/op/reset.t	14 Sep 2017 02:23:21 -0000
@@ -7,7 +7,7 @@ BEGIN {
 }
 use strict;
 
-plan tests => 39;
+plan tests => 40;
 
 package aiieee;
 
@@ -138,6 +138,16 @@ for our $z (*_) {
     }
     is ref\$z, "GLOB", 'reset leaves real-globs-as-scalars as GLOBs';
     is $z, "*main::_", 'And the glob still has the right value';
+}
+
+package _128106 {
+    # Crash on non-globs in the stash.
+    sub u;    # stub without proto
+    sub v($); # proto stub
+    sub w{};  # as of 5.22, $::{w} == \&w
+    $::{x} = undef;
+    reset 'u-x';
+    ::ok (1, "no crash on non-globs in the stash");
 }
 
 # This used to crash under threaded builds, because pmops were remembering
Index: gnu/usr.bin/perl/t/op/sprintf2.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/op/sprintf2.t,v
retrieving revision 1.8
diff -u -p -r1.8 sprintf2.t
--- gnu/usr.bin/perl/t/op/sprintf2.t	5 Feb 2017 00:32:20 -0000	1.8
+++ gnu/usr.bin/perl/t/op/sprintf2.t	14 Sep 2017 02:23:21 -0000
@@ -21,6 +21,7 @@ print "# uvsize = $Config{uvsize}\n";
 print "# nvsize = $Config{nvsize}\n";
 print "# nv_preserves_uv_bits = $Config{nv_preserves_uv_bits}\n";
 print "# d_quad = $Config{d_quad}\n";
+print "# uselongdouble = " . ($Config{uselongdouble} // 'undef') . "\n";
 if ($Config{nvsize} == 8 &&
     (
      # IEEE-754 64-bit ("double precision"), the most common out there
@@ -219,7 +220,7 @@ if ($Config{nvsize} == 8 &&
 	[ '%a', '0.25',    '0x1p-2' ],
 	[ '%a', '0.75',    '0x1.8p-1' ],
 	[ '%a', '3.14',    '0x1.91eb851eb851eb851eb851eb85p+1' ],
-	[ '%a', '-1',      '-0x0p+0' ],
+	[ '%a', '-1',      '-0x1p+0' ],
 	[ '%a', '-3.14',   '-0x1.91eb851eb851eb851eb851eb85p+1' ],
 	[ '%a', '0.1',     '0x1.999999999999999999999999998p-4' ],
 	[ '%a', '1/7',     '0x1.249249249249249249249249248p-3' ],
@@ -262,8 +263,6 @@ if ($Config{nvsize} == 8 &&
     print "# no hexfloat tests\n";
 }
 
-plan tests => 1408 + ($Q ? 0 : 12) + @hexfloat + 12;
-
 use strict;
 use Config;
 
@@ -622,7 +621,7 @@ for my $t (@hexfloat) {
         ok($ok, "'$format' '$arg' -> '$result' cf '$expected'");
         next;
     }
-    unless ($ok) {
+    if (!$ok && $result =~ /\./ && $expected =~ /\./) {
         # It seems that there can be difference in the last bits:
         # [perl #122578]
         #      got "0x1.5bf0a8b14576ap+1"
@@ -721,6 +720,7 @@ SKIP: {
 SKIP: {
     # [perl #127183] Non-canonical hexadecimal floats are parsed prematurely
 
+    # IEEE 754 64-bit
     skip("nv_preserves_uv_bits is $Config{nv_preserves_uv_bits}, not 53", 3)
         unless $Config{nv_preserves_uv_bits} == 53;
 
@@ -749,3 +749,159 @@ SKIP: {
            "non-canonical form");
     }
 }
+
+# These are IEEE 754 64-bit subnormals (formerly known as denormals).
+# Keep these as strings so that non-IEEE-754 don't trip over them.
+my @subnormals = (
+    [ '1e-320', '%a', '0x1.fap-1064' ],
+    [ '1e-321', '%a', '0x1.94p-1067' ],
+    [ '1e-322', '%a', '0x1.4p-1070' ],
+    [ '1e-323', '%a', '0x1p-1073' ],
+    [ '1e-324', '%a', '0x0p+0' ],  # underflow
+    [ '3e-320', '%a', '0x1.7b8p-1062' ],
+    [ '3e-321', '%a', '0x1.2f8p-1065' ],
+    [ '3e-322', '%a', '0x1.e8p-1069' ],
+    [ '3e-323', '%a', '0x1.8p-1072' ],
+    [ '3e-324', '%a', '0x1p-1074' ], # the smallest possible value
+    [ '7e-320', '%a', '0x1.bacp-1061' ],
+    [ '7e-321', '%a', '0x1.624p-1064' ],
+    [ '7e-322', '%a', '0x1.1cp-1067' ],
+    [ '7e-323', '%a', '0x1.cp-1071' ],
+    [ '7e-324', '%a', '0x1p-1074' ], # the smallest possible value, again
+    [ '3e-320', '%.4a', '0x1.7b80p-1062' ],
+    [ '3e-321', '%.4a', '0x1.2f80p-1065' ],
+    [ '3e-322', '%.4a', '0x1.e800p-1069' ],
+    [ '3e-323', '%.4a', '0x1.8000p-1072' ],
+    [ '3e-324', '%.4a', '0x1.0000p-1074' ],
+    [ '3e-320', '%.1a', '0x1.8p-1062' ],
+    [ '3e-321', '%.1a', '0x1.3p-1065' ],
+    [ '3e-322', '%.1a', '0x1.ep-1069' ],
+    [ '3e-323', '%.1a', '0x1.8p-1072' ],
+    [ '3e-324', '%.1a', '0x1.0p-1074' ],
+    [ '0x1.fffffffffffffp-1022', '%a', '0x1.fffffffffffffp-1022' ],
+    [ '0x0.fffffffffffffp-1022', '%a', '0x1.ffffffffffffep-1023' ],
+    [ '0x0.7ffffffffffffp-1022', '%a', '0x1.ffffffffffffcp-1024' ],
+    [ '0x0.3ffffffffffffp-1022', '%a', '0x1.ffffffffffff8p-1025' ],
+    [ '0x0.1ffffffffffffp-1022', '%a', '0x1.ffffffffffffp-1026' ],
+    [ '0x0.0ffffffffffffp-1022', '%a', '0x1.fffffffffffep-1027' ],
+    );
+
+SKIP: {
+    # [rt.perl.org #128843]
+    skip("non-IEEE-754-non-64-bit", scalar @subnormals + 34)
+        unless ($Config{nvsize} == 8 &&
+		$Config{nv_preserves_uv_bits} == 53 &&
+		($Config{doublekind} == 3 ||
+		 $Config{doublekind} == 4));
+
+    for my $t (@subnormals) {
+	# Note that "0x1p+2" is not considered numeric,
+	# since neither is "0x12", hence the eval.
+        my $s = sprintf($t->[1], eval $t->[0]);
+        is($s, $t->[2], "subnormal @$t got $s");
+    }
+
+    # [rt.perl.org #128888]
+    is(sprintf("%a", 1.03125),   "0x1.08p+0");
+    is(sprintf("%.1a", 1.03125), "0x1.0p+0");
+    is(sprintf("%.0a", 1.03125), "0x1p+0", "[rt.perl.org #128888]");
+
+    # [rt.perl.org #128889]
+    is(sprintf("%.*a", -1, 1.03125), "0x1.08p+0", "[rt.perl.org #128889]");
+
+    # [rt.perl.org #128890]
+    is(sprintf("%a", 0x1.18p+0), "0x1.18p+0");
+    is(sprintf("%.1a", 0x1.08p+0), "0x1.0p+0");
+    is(sprintf("%.1a", 0x1.18p+0), "0x1.2p+0", "[rt.perl.org #128890]");
+    is(sprintf("%.1a", 0x1.28p+0), "0x1.2p+0");
+    is(sprintf("%.1a", 0x1.38p+0), "0x1.4p+0");
+    is(sprintf("%.1a", 0x1.48p+0), "0x1.4p+0");
+    is(sprintf("%.1a", 0x1.58p+0), "0x1.6p+0");
+    is(sprintf("%.1a", 0x1.68p+0), "0x1.6p+0");
+    is(sprintf("%.1a", 0x1.78p+0), "0x1.8p+0");
+    is(sprintf("%.1a", 0x1.88p+0), "0x1.8p+0");
+    is(sprintf("%.1a", 0x1.98p+0), "0x1.ap+0");
+    is(sprintf("%.1a", 0x1.a8p+0), "0x1.ap+0");
+    is(sprintf("%.1a", 0x1.b8p+0), "0x1.cp+0");
+    is(sprintf("%.1a", 0x1.c8p+0), "0x1.cp+0");
+    is(sprintf("%.1a", 0x1.d8p+0), "0x1.ep+0");
+    is(sprintf("%.1a", 0x1.e8p+0), "0x1.ep+0");
+    is(sprintf("%.1a", 0x1.f8p+0), "0x2.0p+0");
+
+    is(sprintf("%.1a", 0x1.10p+0), "0x1.1p+0");
+    is(sprintf("%.1a", 0x1.17p+0), "0x1.1p+0");
+    is(sprintf("%.1a", 0x1.19p+0), "0x1.2p+0");
+    is(sprintf("%.1a", 0x1.1fp+0), "0x1.2p+0");
+
+    is(sprintf("%.2a", 0x1.fffp+0), "0x2.00p+0");
+    is(sprintf("%.2a", 0xf.fffp+0), "0x2.00p+3");
+
+    # [rt.perl.org #128893]
+    is(sprintf("%020a", 1.5), "0x0000000000001.8p+0");
+    is(sprintf("%020a", -1.5), "-0x000000000001.8p+0", "[rt.perl.org #128893]");
+    is(sprintf("%+020a", 1.5), "+0x000000000001.8p+0", "[rt.perl.org #128893]");
+    is(sprintf("% 020a", 1.5), " 0x000000000001.8p+0", "[rt.perl.org #128893]");
+    is(sprintf("%20a", -1.5), "           -0x1.8p+0");
+    is(sprintf("%+20a", 1.5), "           +0x1.8p+0");
+    is(sprintf("% 20a", 1.5), "            0x1.8p+0");
+}
+
+# x86 80-bit long-double tests for
+# rt.perl.org #128843, #128888, #128889, #128890, #128893, #128909
+SKIP: {
+    skip("non-80-bit-long-double", 17)
+        unless ($Config{uselongdouble} &&
+		($Config{nvsize} == 16 || $Config{nvsize} == 12) &&
+		($Config{longdblkind} == 3 ||
+		 $Config{longdblkind} == 4));
+
+    {
+        # The last normal for this format.
+	is(sprintf("%a", eval '0x1p-16382'), "0x8p-16385", "[rt.perl.org #128843]");
+
+	# The subnormals cause "exponent underflow" warnings,
+        # but that is not why we are here.
+	local $SIG{__WARN__} = sub {
+	    die "$0: $_[0]" unless $_[0] =~ /exponent underflow/;
+	};
+
+	is(sprintf("%a", eval '0x1p-16383'), "0x4p-16382", "[rt.perl.org #128843]");
+	is(sprintf("%a", eval '0x1p-16384'), "0x2p-16382", "[rt.perl.org #128843]");
+	is(sprintf("%a", eval '0x1p-16385'), "0x1p-16382", "[rt.perl.org #128843]");
+	is(sprintf("%a", eval '0x1p-16386'), "0x8p-16386", "[rt.perl.org #128843]");
+	is(sprintf("%a", eval '0x1p-16387'), "0x4p-16386", "[rt.perl.org #128843]");
+    }
+    is(sprintf("%.0a", 1.03125), "0x8p-3", "[rt.perl.org #128888]");
+    is(sprintf("%.*a", -1, 1.03125), "0x8.4p-3", "[rt.perl.org #128889]");
+    is(sprintf("%.1a", 0x8.18p+0), "0x8.2p+0", "[rt.perl.org #128890]");
+    is(sprintf("%020a", -1.5), "-0x0000000000000cp-3", "[rt.perl.org #128893]");
+    is(sprintf("%+020a", 1.5), "+0x0000000000000cp-3", "[rt.perl.org #128893]");
+    is(sprintf("% 020a", 1.5), " 0x0000000000000cp-3", "[rt.perl.org #128893]");
+    is(sprintf("%a", 1.9999999999999999999), "0xf.fffffffffffffffp-3");
+    is(sprintf("%.3a", 1.9999999999999999999), "0x1.000p+1", "[rt.perl.org #128909]");
+    is(sprintf("%.2a", 1.9999999999999999999), "0x1.00p+1");
+    is(sprintf("%.1a", 1.9999999999999999999), "0x1.0p+1");
+    is(sprintf("%.0a", 1.9999999999999999999), "0x1p+1");
+}
+
+# quadmath tests for rt.perl.org #128843
+SKIP: {
+    skip "need quadmath", 7, unless $Config{usequadmath};
+
+    is(sprintf("%a", eval '0x1p-16382'), '0x1p-16382');  # last normal
+
+    local $SIG{__WARN__} = sub {
+        die "$0: $_[0]" unless $_[0] =~ /exponent underflow/;
+    };
+
+    is(sprintf("%a", eval '0x1p-16383'), '0x1p-16383');
+    is(sprintf("%a", eval '0x1p-16384'), '0x1p-16384');
+
+    is(sprintf("%a", eval '0x1p-16491'), '0x1p-16491');
+    is(sprintf("%a", eval '0x1p-16492'), '0x1p-16492');
+    is(sprintf("%a", eval '0x1p-16493'), '0x1p-16493'); # last denormal
+
+    is(sprintf("%a", eval '0x1p-16494'), '0x1p-16494'); # underflow
+}
+
+done_testing();
Index: gnu/usr.bin/perl/t/op/stash.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/op/stash.t,v
retrieving revision 1.2
diff -u -p -r1.2 stash.t
--- gnu/usr.bin/perl/t/op/stash.t	5 Feb 2017 00:32:20 -0000	1.2
+++ gnu/usr.bin/perl/t/op/stash.t	14 Sep 2017 02:23:21 -0000
@@ -7,7 +7,7 @@ BEGIN {
 
 BEGIN { require "./test.pl"; }
 
-plan( tests => 51 );
+plan( tests => 52 );
 
 # Used to segfault (bug #15479)
 fresh_perl_like(
@@ -334,3 +334,10 @@ is runperl(
    ),
    "ok\n",
    '[perl #123847] no crash from *foo::=*bar::=*glob_with_hash';
+
+is runperl(
+    prog => '%h; *::::::=*h; delete $::{q|::|}; print qq|ok\n|',
+    stderr => 1,
+   ),
+   "ok\n",
+   '[perl #128086] no crash from assigning hash to *:::::: & deleting it';
Index: gnu/usr.bin/perl/t/op/svleak.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/op/svleak.t,v
retrieving revision 1.2
diff -u -p -r1.2 svleak.t
--- gnu/usr.bin/perl/t/op/svleak.t	5 Feb 2017 00:32:20 -0000	1.2
+++ gnu/usr.bin/perl/t/op/svleak.t	14 Sep 2017 02:23:21 -0000
@@ -15,7 +15,7 @@ BEGIN {
 
 use Config;
 
-plan tests => 131;
+plan tests => 132;
 
 # run some code N times. If the number of SVs at the end of loop N is
 # greater than (N-1)*delta at the end of loop 1, we've got a leak
@@ -536,4 +536,14 @@ EOF
     sub h {}
 
     ::leak(5, 0, \&f, q{goto shouldn't leak @_});
+}
+
+# [perl #128313] POSIX warnings shouldn't leak
+{
+    no warnings 'experimental';
+    use re 'strict';
+    my $a = 'aaa';
+    my $b = 'aa';
+    sub f { $a =~ /[^.]+$b/; }
+    ::leak(2, 0, \&f, q{use re 'strict' shouldn't leak warning strings});
 }
Index: gnu/usr.bin/perl/t/op/tr.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/op/tr.t,v
retrieving revision 1.2
diff -u -p -r1.2 tr.t
--- gnu/usr.bin/perl/t/op/tr.t	5 Feb 2017 00:32:20 -0000	1.2
+++ gnu/usr.bin/perl/t/op/tr.t	14 Sep 2017 02:23:22 -0000
@@ -9,7 +9,7 @@ BEGIN {
     set_up_inc('../lib');
 }
 
-plan tests => 164;
+plan tests => 166;
 
 # Test this first before we extend the stack with other operations.
 # This caused an asan failure due to a bad write past the end of the stack.
@@ -641,6 +641,15 @@ for ("", nullrocow) {
 	ok(1, "tr///s on PL_Yes does not assert");
 	eval q{ *x =~ tr///d };
 	ok(1, "tr///d on glob does not assert");
+}
+
+{ # [perl #128734
+    my $string = "\x{00e0}";
+    $string =~ tr/\N{U+00e0}/A/;
+    is($string, "A", 'tr// of \N{U+...} works for upper-Latin1');
+    $string = "\x{00e1}";
+    $string =~ tr/\N{LATIN SMALL LETTER A WITH ACUTE}/A/;
+    is($string, "A", 'tr// of \N{name} works for upper-Latin1');
 }
 
 1;
Index: gnu/usr.bin/perl/t/re/re_tests
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/re/re_tests,v
retrieving revision 1.3
diff -u -p -r1.3 re_tests
--- gnu/usr.bin/perl/t/re/re_tests	5 Feb 2017 00:32:21 -0000	1.3
+++ gnu/usr.bin/perl/t/re/re_tests	14 Sep 2017 02:23:23 -0000
@@ -1966,6 +1966,8 @@ ab(?#Comment){2}c	abbc	y	$&	abbc
 .{1}??	-	c	-	Nested quantifiers
 .{1}?+	-	c	-	Nested quantifiers
 (?:.||)(?|)000000000@	000000000@	y	$&	000000000@		#  [perl #126405]
+aa$|a(?R)a|a	aaa	y	$&	aaa		# [perl 128420] recursive matches
+(?:\1|a)([bcd])\1(?:(?R)|e)\1	abbaccaddedcb	y	$&	abbaccaddedcb		# [perl 128420] recursive match with backreferences
 
 # Keep these lines at the end of the file
 # vim: softtabstop=0 noexpandtab
Index: gnu/usr.bin/perl/t/re/reg_mesg.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/re/reg_mesg.t,v
retrieving revision 1.3
diff -u -p -r1.3 reg_mesg.t
--- gnu/usr.bin/perl/t/re/reg_mesg.t	5 Feb 2017 00:32:21 -0000	1.3
+++ gnu/usr.bin/perl/t/re/reg_mesg.t	14 Sep 2017 02:23:23 -0000
@@ -220,8 +220,8 @@ my @death =
  '/(?[ \x{} ])/' => 'Number with no digits {#} m/(?[ \x{}{#} ])/',
  '/(?[ \cK + ) ])/' => 'Unexpected \')\' {#} m/(?[ \cK + ){#} ])/',
  '/(?[ \cK + ])/' => 'Incomplete expression within \'(?[ ])\' {#} m/(?[ \cK + {#}])/',
- '/(?[ ( ) ])/' => 'Incomplete expression within \'(?[ ])\' {#} m/(?[ ( ) {#}])/',
- '/(?[[0]+()+])/' => 'Incomplete expression within \'(?[ ])\' {#} m/(?[[0]+()+{#}])/',
+ '/(?[ ( ) ])/' => 'Incomplete expression within \'(?[ ])\' {#} m/(?[ ( ){#} ])/',
+ '/(?[[0]+()+])/' => 'Incomplete expression within \'(?[ ])\' {#} m/(?[[0]+(){#}+])/',
  '/(?[ \p{foo} ])/' => 'Can\'t find Unicode property definition "foo" {#} m/(?[ \p{foo}{#} ])/',
  '/(?[ \p{ foo = bar } ])/' => 'Can\'t find Unicode property definition "foo = bar" {#} m/(?[ \p{ foo = bar }{#} ])/',
  '/(?[ \8 ])/' => 'Unrecognized escape \8 in character class {#} m/(?[ \8{#} ])/',
@@ -266,8 +266,9 @@ my @death =
  '/(?[\ -!])/' => 'Incomplete expression within \'(?[ ])\' {#} m/(?[\ -!{#}])/',    # [perl #126180]
  '/(?[\ ^!])/' => 'Incomplete expression within \'(?[ ])\' {#} m/(?[\ ^!{#}])/',    # [perl #126180]
  '/(?[\ |!])/' => 'Incomplete expression within \'(?[ ])\' {#} m/(?[\ |!{#}])/',    # [perl #126180]
- '/(?[()-!])/' => 'Incomplete expression within \'(?[ ])\' {#} m/(?[()-!{#}])/',    # [perl #126204]
+ '/(?[()-!])/' => 'Incomplete expression within \'(?[ ])\' {#} m/(?[(){#}-!])/',    # [perl #126204]
  '/(?[!()])/' => 'Incomplete expression within \'(?[ ])\' {#} m/(?[!(){#}])/',      # [perl #126404]
+ '/(?<=/' => 'Sequence (?... not terminated {#} m/(?<={#}/',                        # [perl #128170]
 );
 
 # These are messages that are warnings when not strict; death under 'use re
Index: gnu/usr.bin/perl/t/re/regex_sets.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/re/regex_sets.t,v
retrieving revision 1.2
diff -u -p -r1.2 regex_sets.t
--- gnu/usr.bin/perl/t/re/regex_sets.t	5 Feb 2017 00:32:21 -0000	1.2
+++ gnu/usr.bin/perl/t/re/regex_sets.t	14 Sep 2017 02:23:23 -0000
@@ -182,6 +182,21 @@ for my $char ("٠", "٥", "٩") {
                     'qr/qr/(?[ ! ( ! (\w)])/');
 }
 
+{   # RT #129122
+    my $pat = '(?[ ( [ABC] - [B] ) + ( [abc] - [b] ) + [def] ])';
+    like("A", qr/$pat/, "'A' matches /$pat/");
+    unlike("B", qr/$pat/, "'B' doesn't match /$pat/");
+    like("C", qr/$pat/, "'C' matches /$pat/");
+    unlike("D", qr/$pat/, "'D' doesn't match /$pat/");
+    like("a", qr/$pat/, "'a' matches /$pat/");
+    unlike("b", qr/$pat/, "'b' doesn't match /$pat/");
+    like("c", qr/$pat/, "'c' matches /$pat/");
+    like("d", qr/$pat/, "'d' matches /$pat/");
+    like("e", qr/$pat/, "'e' matches /$pat/");
+    like("f", qr/$pat/, "'f' matches /$pat/");
+    unlike("g", qr/$pat/, "'g' doesn't match /$pat/");
+}
+
 done_testing();
 
 1;
Index: gnu/usr.bin/perl/t/run/switchx.aux
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/run/switchx.aux,v
retrieving revision 1.1.1.4
diff -u -p -r1.1.1.4 switchx.aux
--- gnu/usr.bin/perl/t/run/switchx.aux	24 Mar 2014 14:59:11 -0000	1.1.1.4
+++ gnu/usr.bin/perl/t/run/switchx.aux	14 Sep 2017 02:23:23 -0000
@@ -17,11 +17,12 @@ still not perl
 
 #!/some/path/that/leads/to/perl -l
 
-print "1..7";
+print "1..8";
+print "ok 1 - Correct line number" if __LINE__ == 4;
 if (-f 'run/switchx.aux') {
-    print "ok 1 - Test file exists";
+    print "ok 2 - Test file exists";
 }
-print "ok 2 - Test file utilized";
+print "ok 3 - Test file utilized";
 # other tests are in switchx2.aux
 
 __END__
Index: gnu/usr.bin/perl/t/run/switchx.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/run/switchx.t,v
retrieving revision 1.1.1.3
diff -u -p -r1.1.1.3 switchx.t
--- gnu/usr.bin/perl/t/run/switchx.t	25 Mar 2013 20:09:38 -0000	1.1.1.3
+++ gnu/usr.bin/perl/t/run/switchx.t	14 Sep 2017 02:23:23 -0000
@@ -15,9 +15,9 @@ print runperl( switches => ['-x'],
 # Test '-xdir'
 print runperl( switches => ['-x./run'],
                progfile => 'run/switchx2.aux',
-               args     => [ 3 ] );
+               args     => [ 4 ] );
 
-curr_test(5);
+curr_test(6);
 
 # Test the error message for not found
 like(runperl(switches => ['-x'], progfile => 'run/switchx3.aux', stderr => 1),
Index: gnu/usr.bin/perl/t/win32/runenv.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/win32/runenv.t,v
retrieving revision 1.2
diff -u -p -r1.2 runenv.t
--- gnu/usr.bin/perl/t/win32/runenv.t	5 Feb 2017 00:32:21 -0000	1.2
+++ gnu/usr.bin/perl/t/win32/runenv.t	14 Sep 2017 02:23:24 -0000
@@ -14,10 +14,10 @@ BEGIN {
     require Win32;
     ($::os_id, $::os_major) = ( Win32::GetOSVersion() )[ 4, 1 ];
     if ($::os_id == 2 and $::os_major == 6) {    # Vista, Server 2008 (incl R2), 7
-	$::tests = 43;
+	$::tests = 45;
     }
     else {
-	$::tests = 40;
+	$::tests = 42;
     }
 
     require './test.pl';
@@ -70,11 +70,12 @@ sub runperl_and_capture {
 }
 
 sub try {
-  my ($env, $args, $stdout, $stderr) = @_;
+  my ($env, $args, $stdout, $stderr, $name) = @_;
   my ($actual_stdout, $actual_stderr) = runperl_and_capture($env, $args);
+  $name ||= "";
   local $::Level = $::Level + 1;
-  is $actual_stdout, $stdout;
-  is $actual_stderr, $stderr;
+  is $actual_stdout, $stdout, "$name - stdout";
+  is $actual_stderr, $stderr, "$name - stderr";
 }
 
 #  PERL5OPT    Command-line options (switches).  Switches in
@@ -195,6 +196,16 @@ try({PERL5LIB => "foo",
     ['-e', '"print grep { $_ eq \"bar\" } @INC"'],
     '',
     '');
+
+{
+    # 131665
+    # crashes without the fix
+    my $longname = "X" x 2048;
+    try({ $longname => 1 },
+        [ '-e', '"print q/ok/"' ],
+        'ok', '',
+        'very long env var names' );
+}
 
 # Tests for S_incpush_use_sep():
 
Index: gnu/usr.bin/perl/vms/descrip_mms.template
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/vms/descrip_mms.template,v
retrieving revision 1.4
diff -u -p -r1.4 descrip_mms.template
--- gnu/usr.bin/perl/vms/descrip_mms.template	14 Aug 2017 13:48:48 -0000	1.4
+++ gnu/usr.bin/perl/vms/descrip_mms.template	14 Sep 2017 02:23:24 -0000
@@ -307,7 +307,7 @@ utils : $(utils1) $(utils2) $(utils3) $(
 extra.pods : miniperl
 	@ @extra_pods.com
 
-PERLDELTA_CURRENT = [.pod]perl5242delta.pod
+PERLDELTA_CURRENT = [.pod]perl5243delta.pod
 
 $(PERLDELTA_CURRENT) : [.pod]perldelta.pod
 	Copy/NoConfirm/Log $(MMS$SOURCE) $(PERLDELTA_CURRENT)
Index: gnu/usr.bin/perl/win32/GNUmakefile
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/win32/GNUmakefile,v
retrieving revision 1.4
diff -u -p -r1.4 GNUmakefile
--- gnu/usr.bin/perl/win32/GNUmakefile	14 Aug 2017 13:50:32 -0000	1.4
+++ gnu/usr.bin/perl/win32/GNUmakefile	14 Sep 2017 02:23:25 -0000
@@ -67,7 +67,7 @@ INST_TOP := $(INST_DRV)\perl
 # versioned installation can be obtained by setting INST_TOP above to a
 # path that includes an arbitrary version string.
 #
-#INST_VER	:= \5.24.2
+#INST_VER	:= \5.24.3
 
 #
 # Comment this out if you DON'T want your perl installation to have
@@ -1544,7 +1544,7 @@ utils: $(HAVEMINIPERL) ..\utils\Makefile
 	copy ..\README.tw       ..\pod\perltw.pod
 	copy ..\README.vos      ..\pod\perlvos.pod
 	copy ..\README.win32    ..\pod\perlwin32.pod
-	copy ..\pod\perldelta.pod ..\pod\perl5242delta.pod
+	copy ..\pod\perldelta.pod ..\pod\perl5243delta.pod
 	$(MINIPERL) -I..\lib $(PL2BAT) $(UTILS)
 	$(MINIPERL) -I..\lib ..\autodoc.pl ..
 	$(MINIPERL) -I..\lib ..\pod\perlmodlib.PL -q ..
@@ -1640,7 +1640,7 @@ distclean: realclean
 	-if exist $(LIBDIR)\Win32API rmdir /s /q $(LIBDIR)\Win32API
 	-if exist $(LIBDIR)\XS rmdir /s /q $(LIBDIR)\XS
 	-cd $(PODDIR) && del /f *.html *.bat roffitall \
-	    perl5242delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
+	    perl5243delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
 	    perlapi.pod perlbs2000.pod perlce.pod perlcn.pod perlcygwin.pod \
 	    perldos.pod perlfreebsd.pod perlhaiku.pod perlhpux.pod \
 	    perlhurd.pod perlintern.pod perlirix.pod perljp.pod perlko.pod \
Index: gnu/usr.bin/perl/win32/Makefile
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/win32/Makefile,v
retrieving revision 1.28
diff -u -p -r1.28 Makefile
--- gnu/usr.bin/perl/win32/Makefile	14 Aug 2017 13:50:32 -0000	1.28
+++ gnu/usr.bin/perl/win32/Makefile	14 Sep 2017 02:23:25 -0000
@@ -38,7 +38,7 @@ INST_TOP	= $(INST_DRV)\perl
 # versioned installation can be obtained by setting INST_TOP above to a
 # path that includes an arbitrary version string.
 #
-#INST_VER	= \5.24.2
+#INST_VER	= \5.24.3
 
 #
 # Comment this out if you DON'T want your perl installation to have
@@ -1215,7 +1215,7 @@ utils: $(PERLEXE) ..\utils\Makefile
 	copy ..\README.tw       ..\pod\perltw.pod
 	copy ..\README.vos      ..\pod\perlvos.pod
 	copy ..\README.win32    ..\pod\perlwin32.pod
-	copy ..\pod\perldelta.pod ..\pod\perl5242delta.pod
+	copy ..\pod\perldelta.pod ..\pod\perl5243delta.pod
 	cd ..\win32
 	$(PERLEXE) $(PL2BAT) $(UTILS)
 	$(MINIPERL) -I..\lib ..\autodoc.pl ..
@@ -1314,7 +1314,7 @@ distclean: realclean
 	-if exist $(LIBDIR)\Win32API rmdir /s /q $(LIBDIR)\Win32API
 	-if exist $(LIBDIR)\XS rmdir /s /q $(LIBDIR)\XS
 	-cd $(PODDIR) && del /f *.html *.bat roffitall \
-	    perl5242delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
+	    perl5243delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
 	    perlapi.pod perlbs2000.pod perlce.pod perlcn.pod perlcygwin.pod \
 	    perldos.pod perlfreebsd.pod perlhaiku.pod perlhpux.pod \
 	    perlhurd.pod perlintern.pod perlirix.pod perljp.pod perlko.pod \
Index: gnu/usr.bin/perl/win32/makefile.mk
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/win32/makefile.mk,v
retrieving revision 1.28
diff -u -p -r1.28 makefile.mk
--- gnu/usr.bin/perl/win32/makefile.mk	14 Aug 2017 13:50:32 -0000	1.28
+++ gnu/usr.bin/perl/win32/makefile.mk	14 Sep 2017 02:23:26 -0000
@@ -44,7 +44,7 @@ INST_TOP	*= $(INST_DRV)\perl
 # versioned installation can be obtained by setting INST_TOP above to a
 # path that includes an arbitrary version string.
 #
-#INST_VER	*= \5.24.2
+#INST_VER	*= \5.24.3
 
 #
 # Comment this out if you DON'T want your perl installation to have
@@ -1511,7 +1511,7 @@ utils: $(HAVEMINIPERL) ..\utils\Makefile
 	copy ..\README.tw       ..\pod\perltw.pod
 	copy ..\README.vos      ..\pod\perlvos.pod
 	copy ..\README.win32    ..\pod\perlwin32.pod
-	copy ..\pod\perldelta.pod ..\pod\perl5242delta.pod
+	copy ..\pod\perldelta.pod ..\pod\perl5243delta.pod
 	$(MINIPERL) -I..\lib $(PL2BAT) $(UTILS)
 	$(MINIPERL) -I..\lib ..\autodoc.pl ..
 	$(MINIPERL) -I..\lib ..\pod\perlmodlib.PL -q ..
@@ -1609,7 +1609,7 @@ distclean: realclean
 	-if exist $(LIBDIR)\Win32API rmdir /s /q $(LIBDIR)\Win32API
 	-if exist $(LIBDIR)\XS rmdir /s /q $(LIBDIR)\XS
 	-cd $(PODDIR) && del /f *.html *.bat roffitall \
-	    perl5242delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
+	    perl5243delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
 	    perlapi.pod perlbs2000.pod perlce.pod perlcn.pod perlcygwin.pod \
 	    perldos.pod perlfreebsd.pod perlhaiku.pod perlhpux.pod \
 	    perlhurd.pod perlintern.pod perlirix.pod perljp.pod perlko.pod \
Index: gnu/usr.bin/perl/win32/perlhost.h
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/win32/perlhost.h,v
retrieving revision 1.2
diff -u -p -r1.2 perlhost.h
--- gnu/usr.bin/perl/win32/perlhost.h	5 Feb 2017 00:32:22 -0000	1.2
+++ gnu/usr.bin/perl/win32/perlhost.h	14 Sep 2017 02:23:26 -0000
@@ -2177,17 +2177,11 @@ compare(const void *arg1, const void *ar
 void
 CPerlHost::Add(LPCSTR lpStr)
 {
-    char szBuffer[1024];
     LPSTR *lpPtr;
-    int index, length = strlen(lpStr)+1;
-
-    for(index = 0; lpStr[index] != '\0' && lpStr[index] != '='; ++index)
-	szBuffer[index] = lpStr[index];
-
-    szBuffer[index] = '\0';
+    STRLEN length = strlen(lpStr)+1;
 
     // replacing ?
-    lpPtr = Lookup(szBuffer);
+    lpPtr = Lookup(lpStr);
     if (lpPtr != NULL) {
 	// must allocate things via host memory allocation functions 
 	// rather than perl's Renew() et al, as the perl interpreter
Index: gnu/usr.bin/perl/win32/pod.mak
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/win32/pod.mak,v
retrieving revision 1.19
diff -u -p -r1.19 pod.mak
--- gnu/usr.bin/perl/win32/pod.mak	14 Aug 2017 13:48:48 -0000	1.19
+++ gnu/usr.bin/perl/win32/pod.mak	14 Sep 2017 02:23:26 -0000
@@ -44,9 +44,11 @@ POD = perl.pod	\
 	perl5221delta.pod	\
 	perl5222delta.pod	\
 	perl5223delta.pod	\
+	perl5224delta.pod	\
 	perl5240delta.pod	\
 	perl5241delta.pod	\
 	perl5242delta.pod	\
+	perl5243delta.pod	\
 	perl561delta.pod	\
 	perl56delta.pod	\
 	perl581delta.pod	\
@@ -185,9 +187,11 @@ MAN = perl.man	\
 	perl5221delta.man	\
 	perl5222delta.man	\
 	perl5223delta.man	\
+	perl5224delta.man	\
 	perl5240delta.man	\
 	perl5241delta.man	\
 	perl5242delta.man	\
+	perl5243delta.man	\
 	perl561delta.man	\
 	perl56delta.man	\
 	perl581delta.man	\
@@ -326,9 +330,11 @@ HTML = perl.html	\
 	perl5221delta.html	\
 	perl5222delta.html	\
 	perl5223delta.html	\
+	perl5224delta.html	\
 	perl5240delta.html	\
 	perl5241delta.html	\
 	perl5242delta.html	\
+	perl5243delta.html	\
 	perl561delta.html	\
 	perl56delta.html	\
 	perl581delta.html	\
@@ -467,9 +473,11 @@ TEX = perl.tex	\
 	perl5221delta.tex	\
 	perl5222delta.tex	\
 	perl5223delta.tex	\
+	perl5224delta.tex	\
 	perl5240delta.tex	\
 	perl5241delta.tex	\
 	perl5242delta.tex	\
+	perl5243delta.tex	\
 	perl561delta.tex	\
 	perl56delta.tex	\
 	perl581delta.tex	\
